//
// SourceMod Script
//
// Developed by Misery
// DECEMBRE 2008
// http://thelw.forum-actif.net
//
// CHANGELOG :
// - 04.03.2009 Version 1.0.2
// - Teleport entity with a new angle
//

#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0.2"
#define MAXMODELS 11

public Plugin:myinfo = 
{
	name = "Fast dam MOD",
	author = "Misery",
	description = "MOD where we can put Fast dam",
	version = PLUGIN_VERSION,
	url = "http://thelw.forum-actif.net"
};

new Handle:Cvar_FastDam_Enable
new Handle:Cvar_FastDam_Number
new Handle:Cvar_FastDam_Bonus_Dead

new Handle:fd_InfoMod[MAXPLAYERS + 1]
new fd_model_index[MAXMODELS + 1]

new ObjetAlea
new DamCount[64]

new String:fd_model_name[][] = {
	"models/props_furniture/table1.mdl",
	"models/props_crates/woodbarrel001.mdl",
	"models/props_furniture/dresser1.mdl",
	"models/props_foliage/flower_barrel.mdl",
	"models/props_italian/gramophone.mdl",
	"models/props_furniture/piano.mdl",
	"models/props_furniture/bathtub1.mdl",
	"models/props_furniture/bedframe_single.mdl",
	"models/props_furniture/cabinet_large.mdl",
	"models/props_furniture/desk1.mdl",
	"models/props_foliage/potted_plant3.mdl"
	}

public OnPluginStart()
{
        CreateConVar("sm_dod_FastDam_version", PLUGIN_VERSION, "DoD:S Fast dam Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)
	
	RegConsoleCmd("dam", Command_Fast_Dam, "Fast dam for DoD:S Fast dam.")
	
	Cvar_FastDam_Enable = CreateConVar("sm_fastdam_enable", "1", "Enable/disable DoD:S Fast dam Mod", FCVAR_PLUGIN)

	Cvar_FastDam_Number = CreateConVar("sm_fastdam_number", "2", "Number of object to use by player", FCVAR_PLUGIN)
	Cvar_FastDam_Bonus_Dead = CreateConVar("sm_FastDam_Bonus_Dead_enable", "1", "Enable/disable DoD:S Fast dam Bonus", FCVAR_PLUGIN)
	
	HookEvent("player_spawn", PlayerSpawnEvent)	
	HookEvent("player_death", PlayerDeathEvent)
	HookEvent("player_disconnect", PlayerDisconnectEvent)
	
	PrintToServer("----------------|         Sm_Dod_FastDam Loaded         |---------------")
}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", PlayerSpawnEvent)
	UnhookEvent("player_death", PlayerDeathEvent)
	UnhookEvent("player_disconnect", PlayerDisconnectEvent)
}

public OnMapStart()
{
	//models
	for (new i = 0; i < MAXMODELS; i++)
	{
		fd_model_index[i] = PrecacheModel(fd_model_name[i], true)
	}
}

public OnClientPutInServer (client)
{
	if((client == 0) || !IsClientConnected (client))
	{
		return
	}
	
	fd_InfoMod[client] = CreateTimer (20.0, InfoMod, client, TIMER_FLAG_NO_MAPCHANGE)
}

public PlayerSpawnEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	
	if(client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return
	}
	
	if(GetConVarInt(Cvar_FastDam_Enable) == 1)
	{
		DamCount[client] = GetConVarInt(Cvar_FastDam_Number)
	}
}

public PlayerDeathEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	new attacker   = GetClientOfUserId(GetEventInt(event, "attacker"))
	
	if(client == 0 || attacker == 0 || !IsClientInGame(client) || IsFakeClient(client))
	{
		return
	}
	
	if(GetConVarInt(Cvar_FastDam_Enable) == 1)
	{
         	if (attacker == 0 || !IsPlayerAlive(attacker))
         	{
            		return
         	}
		
		if((GetConVarInt(Cvar_FastDam_Bonus_Dead) == 1))
		{
			DamCount[attacker] = DamCount[attacker] + 1
			PrintToChat(attacker, "\x01\x04[FAST DAM]\x01 You have win an object")

			//Reinitialise les compteurs
			DamCount[client] = 0
		}
	}
}

public PlayerDisconnectEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	
	if(client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return
	}
	
	if(GetConVarInt(Cvar_FastDam_Enable) == 1 && !IsClientInGame(client))
	{
		//Reinitialise les compteurs
		DamCount[client] = 0
	}
}

public Action:Command_Fast_Dam(client, args)
{
	if(client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return
	}
	
	if(GetConVarInt(Cvar_FastDam_Enable) == 1 && IsClientInGame(client))
	{
		if (DamCount[client] > 0)
		{
			DamCount[client] = DamCount[client] - 1
			PrintCenterText(client,"Objects Dam : %i", DamCount[client])

			decl Float:pos_player[3]
  			GetClientAbsOrigin(client, pos_player)

			new objet_dam =  CreateEntityByName("prop_physics")
		
			ObjetAlea = GetRandomInt(0, MAXMODELS - 1)
		
			SetEntityModel(objet_dam, fd_model_name[ObjetAlea])
			
	 		DispatchKeyValue(objet_dam, "StartDisabled", "false")
			DispatchSpawn(objet_dam)
			
			new Float:vspeed = 40.0
			new Float:hspeed = 60.0
			GetClientEyePosition(client, pos_player)
			
			new Float:angle[3]
			new Float:speed[3]
			GetClientEyeAngles(client, angle)
			GetAngleVectors(angle, speed, NULL_VECTOR, NULL_VECTOR)
			
			pos_player[0] += 48.0 * Cosine(0.0174532925 * angle[1])
			pos_player[1] += 48.0 * Sine(0.0174532925 * angle[1])
			speed[0]*=vspeed; speed[1]*=hspeed; speed[2]=hspeed

			TeleportEntity(objet_dam, pos_player, NULL_VECTOR, speed)
		}
		else
		{
			PrintCenterText(client,"Objects Dam : %i", DamCount[client])
		}
	}
}

public Action:InfoMod (Handle:timer, any:client)
{
	fd_InfoMod[client] = INVALID_HANDLE
	
	if(GetConVarInt(Cvar_FastDam_Enable) == 1 && IsClientConnected (client) && IsClientInGame (client) && !IsFakeClient(client))
	{
		//Thanks to the Developper, let his name please !
		PrintToChat (client, "\x01\x04[FAST DAM]\x01 FAST DAM by Misery : \x01\x04ON\x01")
		PrintToChat (client, "\x01\x04\x01 Say !dam for have randomly objects")
	}
	
	return Plugin_Handled
}